<?php

/**
 * pension_func actions.
 *
 * @package    nomina
 * @subpackage pension_func
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class pension_funcActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_PENSION_FUNC',
        'NO_DATOS_FUNCIONARIO_V',
        'NO_PERIODO_V',
        'NO_TIPO_PERIODO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'id_tipo_doc' => 'NO_PENSION_FUNC',
            'num_doc' => 'NO_PENSION_FUNC'
        ),
        'NO_PERIODO_V' =>
        array(
            'id_periodo' => 'NO_PENSION_FUNC'
        ),
        'NO_TIPO_PERIODO' =>
        array(
            'id_tipo_periodo' => 'NO_PERIODO_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_PENSION_FUNC' =>
        array(
            'id_pension_func' => 'id_pension_func',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'id_periodo' => 'id_periodo',
            'estado' => 'estado',
            'fecha_doc' => 'fecha_doc',
            'numero_doc' => 'numero_doc',
            'fecha_pension' => 'fecha_pension',
            'id_suptipo_cotizante'=>'id_suptipo_cotizante'
        ),
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'nombre_completo' => 'nombre_completo',
            'nombre_apellido' => 'nombre_apellido'
        ),
        'NO_PERIODO_V' =>
        array(
            'id_meses' => 'id_meses',
            'id_anhos' => 'id_anhos',
            'periodo' => 'periodo'
        ),
        'NO_TIPO_PERIODO' =>
        array(
            'descripcion' => 'descripcion_periodo'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * EJEMPLO: 'titular' => array('NULL' => array('titular')),
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_PENSION_FUNC' => array(
            'id_pension_func,a' => array('!=' => array(-1)),
            'id_pension_func,b' => array('=' => array('id_pension_func')),
            'id_tipo_doc' => array('=' => array('id_tipo_doc')),
            'num_doc' => array('=' => array('num_doc')),
            'estado' => array('=' => array('estado')),
            'id_periodo' => array('=' => array('id_periodo_filtro')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'num_doc'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_pension_func'; //identificador de la tabla - solo si es un dato no llave compuesta
    protected $id_names = array('id_pension_func'); //llave primaria
    protected $field_names = array('id_tipo_doc', 'num_doc', 'id_periodo', 'estado', 'fecha_doc', 'numero_doc', 'fecha_pension','id_suptipo_cotizante'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_PENSION_FUNC'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * campos para fecha sistema
     */
//    protected $campo_fecha_sistema = array(
//        'fecha_crea'
//    );

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_pension_func'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */
        $id_tipo_doc = $request['id_tipo_doc'];
        $num_doc = $request['num_doc'];

        /*
         *  Validar la operación, ya sea por SQL
         */
        $sql = <<<EOD
select * 
from no_pension_func
where
id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc'
and estado = 1
EOD;
        $records = CN_TABLE::executeSQL($sql);
        /*
         *  Generar errores en $errors
         */
        if (count($records) > 0) {
            $errors['mensaje'] = "El funcionario ya posee un registro de pensión activo.";
            $errors['servicio'] = "pension_func";
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */
//        $id_tipo_doc = $request['id_tipo_doc'];
//        $num_doc = $request['num_doc'];

        /*
         *  Validar la operación, ya sea por SQL
         */
//        $sql = <<<EOD
//select * 
//from no_pension_func
//where
//id_tipo_doc = $id_tipo_doc
//and num_doc = '$num_doc'
//and estado = 1
//EOD;
//        $records = CN_TABLE::executeSQL($sql);
        /*
         *  Generar errores en $errors
         */
//        if (count($records) > 0) {
//            $errors['mensaje'] = "El funcionario ya posee un registro de pensión activo.";
//            $errors['servicio'] = "pension_func";
//        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");
        
        
         foreach ($request->getPostParameters() as $key => $value) {
            $logger->info("[suptipo_cotizante] request[$key] = $value\n");
            
        }
        $logger->info("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $logger->info("[suptipo_cotizante]  request[$key] = $value");
            
        }
        $logger->info("---END Logging request");
        
        
        

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            /*
             * Variables request
             */
            $fecha_pension = $request['fecha_pension'];
            $id_tipo_doc = $request['id_tipo_doc'];
            $num_doc = $request['num_doc'];

            /*
             * Trear registro de afiliacion de pension activa
             */
            $sql = <<<EOD

select * 
from no_afilia_fondo
where
id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc'
and id_clase_fondo = 1
and estado = 1
EOD;

            $results = CN_TABLE::executeSQL($sql);

            foreach ($results as $res) {

                $id_afilia_fondo = $res['id_afilia_fondo'];

                $sql = <<<EOD
update no_afilia_fondo set fecha_retiro = to_date('$fecha_pension','yyyy-mm-dd') - 1, estado = 0 
where id_afilia_fondo = $id_afilia_fondo
EOD;
                CN_TABLE::executeSQL($sql);
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id_tipo_doc = $list_data_post[0]['id_tipo_doc'];
                $num_doc = $list_data_post[0]['num_doc'];
                $fecha_retiro = $list_data_post[0]['fecha_pension'];

                /*
                 * Trear registro de afiliacion de pension activa
                 */
                $sql = <<<EOD
select 
*
from no_afilia_fondo
where
id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc'
and id_clase_fondo = 1
and rownum = 1
order by
fecha_ingreso desc, id_afilia_fondo desc
EOD;

                $results = CN_TABLE::executeSQL($sql);

                foreach ($results as $res) {

                    $id_mae_fondos = $res['id_mae_fondos'];
                    $id_tipo_aporte = $res['id_tipo_aporte'];

                    /*
                     * Trear registro de afiliacion de pension activa
                     */
                    $sql = <<<EOD
select descto.porcentaje_func AS PORCENTAJE, 
descto.rango_desde, descto.rango_hasta, foncon.id_concep_nomina
from no_descto_detalle descto
LEFT JOIN no_fondo_concepto foncon 
ON foncon.id_descuento_ss = descto.id_descuento_ss
where foncon.id_mae_fondos = $id_mae_fondos 
    and descto.id_tipo_aporte = $id_tipo_aporte
EOD;

                    $results_pen = CN_TABLE::executeSQL($sql);

                    foreach ($results_pen as $value) {

                        $id_concepto = $value['id_concep_nomina'];

                        /**
                         * Actualiza concepto funcionario con la fecha de retiro segun  la fecha de pension
                         */
                        $sql = <<<EOD
UPDATE NO_CONCEPTO_FUNC SET ESTADO = 0, ACTUAL = 0, 
    FECHA_HASTA = to_date('$fecha_retiro','YYYY-MM-DD') - 1
   WHERE ID_TIPO_DOC = $id_tipo_doc AND NUM_DOC = $num_doc 
       and ID_CONCEP_NOMINA = $id_concepto and actual = 1
EOD;
                        $this->conn->execute($sql);

                        /**
                         * Elimina el registro de concepto periodo para el mes y anho de la fecha de pension
                         */
                        $sql = <<<EOD
DELETE FROM no_concepto_periodo
   WHERE ID_TIPO_DOC = $id_tipo_doc AND NUM_DOC = $num_doc 
       and ID_CONCEP_NOMINA = $id_concepto
       and id_anhos = extract(year from to_date('$fecha_retiro','YYYY-MM-DD'))
       and id_meses = extract(month from to_date('$fecha_retiro','YYYY-MM-DD'))
EOD;
                        $this->conn->execute($sql);
                    }
                }

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
